from PyQt4 import QtCore

class BackgroundTask(QtCore.QThread):
	"""BackgroundTask class """
	
	def __init__(self, parent = None):
		"""Initialization function for BackgroundTask"""
		super(BackgroundTask, self).__init__()
		self.parent = parent
		self.settings = None
	
	def taskComplete(self, taskName, userMessage):
		self.emit(QtCore.SIGNAL("taskComplete(QString, QString)"), 
			QtCore.QString(taskName), QtCore.QString(userMessage))
	
	def taskError(self, taskName, userMessage):
		self.emit(QtCore.SIGNAL("taskError(QString, QString)"), 
			QtCore.QString(taskName), QtCore.QString(userMessage))
	
	def setupTaskProgress(self, maximum, message = None):
		self.emit(QtCore.SIGNAL("setupTaskProgress(int, QString)"),
			maximum, QtCore.QString(message))
	
	def updateTaskProgress(self, progress):
		self.emit(QtCore.SIGNAL("updateTaskProgress(int)"), progress)
	
	def toggleControls(self, option):
		self.emit(QtCore.SIGNAL("toggleControls(bool)"), option)