from PyQt4 import QtCore
from duplicity import log
import timedrive.utils as utils
from timedrive.utils import duplicity_interface
import backgroundtask

class ManageBackups(backgroundtask.BackgroundTask):
	"""Background task that deletes and manages and deletes backup sets,
	snapshots, and associated metadata"""
	
	opTypeDELETEBACKUP = 1

	def __init__(self, parent = None):
		super(ManageBackups, self).__init__(parent)
		self.operationType = None
		self.backupTime = None
		self.folder = None
	
	def DeleteBackupSet(self, backupTime, folder):
		self.operationType = self.opTypeDELETEBACKUP
		self.backupTime = backupTime
		self.folder = folder
		self.start()
	
	def run(self):
		"""Primary method of the class."""
		
		self.toggleControls(False)
		
		# Delete the Backup Set Specified by self.backupTime and self.folder
		if self.operationType == self.opTypeDELETEBACKUP:
			self.setupTaskProgress(0, "Deleting Backup Set ... ")
			operationResult = utils.DeleteBackup(self.backupTime, self.folder)
			if operationResult == True:
				userMessage = "Backup Deleted Successfully \n" + self.folder.FolderName + "\n -" + utils.time_String2Pretty(self.backupTime)

			else:
				userMessage = "Unable to Delete Backup Set \n" + self.folder.FolderName + "\n -" + utils.time_String2Pretty(self.backupTime)

			self.taskComplete("Delete Backup", userMessage)
		
		self.toggleControls(True)
		
